//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forx-tsd.com"
#property link      "www.forx-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_width3  2
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_minimum 0
#property indicator_maximum 100

//
//
//
//
//

extern int    DeviationsPeriod = 14;
extern int    HighLowPeriod    = 5;
extern int    SumPeriod        = 3;
extern int    SmoothPeriod     = 3;
extern int    Price            = PRICE_CLOSE;
extern double UpTreshold       = 90;
extern double DownTreshold     = 10;

//
//
//
//
//

double bufferUp[];
double bufferDn[];
double stoch[];
double atrstoch[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,bufferUp);
   SetIndexBuffer(1,bufferDn);
   SetIndexBuffer(2,stoch);
         IndicatorShortName("TTI Stochastic extreme ("+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][3];
#define _x1    0
#define _minx1 1
#define _maxx1 2

//
//
//
//
//

int start()
{
   double alpha = 2.0 / (1.0+SmoothPeriod);
   int i,k,r,limit,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
           
           

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
         work[r][_x1] = iStdDev(NULL,0,DeviationsPeriod,0,MODE_SMA,Price,i);
      
         //
         //
         //
         //
         //
         
            work[r][_minx1] = work[r][_x1];
            work[r][_maxx1] = work[r][_x1];
         
               for (k=1; k<HighLowPeriod; k++)
               {
                  work[r][_minx1] = MathMin(work[r][_minx1],work[r-k][_x1]);
                  work[r][_maxx1] = MathMax(work[r][_maxx1],work[r-k][_x1]);
               }

            double sum1 = work[r][_x1]   -work[r][_minx1];
            double sum2 = work[r][_maxx1]-work[r][_minx1];

               for (k=1; k<SumPeriod; k++)
               {
                  sum1 += work[r-k][_x1]   -work[r-k][_minx1];
                  sum2 += work[r-k][_maxx1]-work[r-k][_minx1];
               }
                  
            if (sum2!=0)
                  double x2 = 100.0*sum1/sum2;
            else         x2 = 0;                                       
            stoch[i]    = stoch[i+1]+alpha*(x2-stoch[i+1]);
   
            //
            //
            //
            //
            //
            
            bufferUp[i] = UpTreshold;  
            bufferDn[i] = DownTreshold;  
   }
   
   //
   //
   //
   //
   //
 
   return(0);
}

